
package net.mcreator.testmore.item;

import net.minecraftforge.registries.ForgeRegistries;

import net.minecraft.world.item.crafting.Ingredient;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.Item;
import net.minecraft.world.item.ArmorMaterial;
import net.minecraft.world.item.ArmorItem;
import net.minecraft.world.entity.EquipmentSlot;
import net.minecraft.world.entity.Entity;
import net.minecraft.sounds.SoundEvent;
import net.minecraft.resources.ResourceLocation;

import net.mcreator.testmore.init.TestmoreModTabs;
import net.mcreator.testmore.init.TestmoreModBlocks;

public abstract class OnlyNAItem extends ArmorItem {
	public OnlyNAItem(EquipmentSlot slot, Item.Properties properties) {
		super(new ArmorMaterial() {
			@Override
			public int getDurabilityForSlot(EquipmentSlot slot) {
				return new int[]{13, 15, 16, 11}[slot.getIndex()] * 55;
			}

			@Override
			public int getDefenseForSlot(EquipmentSlot slot) {
				return new int[]{4, 9, 13, 5}[slot.getIndex()];
			}

			@Override
			public int getEnchantmentValue() {
				return 30;
			}

			@Override
			public SoundEvent getEquipSound() {
				return ForgeRegistries.SOUND_EVENTS.getValue(new ResourceLocation(""));
			}

			@Override
			public Ingredient getRepairIngredient() {
				return Ingredient.of(new ItemStack(TestmoreModBlocks.LUCKY_BLOCK.get()));
			}

			@Override
			public String getName() {
				return "only_na";
			}

			@Override
			public float getToughness() {
				return 4f;
			}

			@Override
			public float getKnockbackResistance() {
				return 0.25f;
			}
		}, slot, properties);
	}

	public static class Helmet extends OnlyNAItem {
		public Helmet() {
			super(EquipmentSlot.HEAD, new Item.Properties().tab(TestmoreModTabs.TAB_ADVANCED_MINECRAFT_MOD));
		}

		@Override
		public String getArmorTexture(ItemStack stack, Entity entity, EquipmentSlot slot, String type) {
			return "testmore:textures/models/armor/netheritearmor_layer_1.png";
		}
	}

	public static class Chestplate extends OnlyNAItem {
		public Chestplate() {
			super(EquipmentSlot.CHEST, new Item.Properties().tab(TestmoreModTabs.TAB_ADVANCED_MINECRAFT_MOD));
		}

		@Override
		public String getArmorTexture(ItemStack stack, Entity entity, EquipmentSlot slot, String type) {
			return "testmore:textures/models/armor/netheritearmor_layer_1.png";
		}
	}

	public static class Leggings extends OnlyNAItem {
		public Leggings() {
			super(EquipmentSlot.LEGS, new Item.Properties().tab(TestmoreModTabs.TAB_ADVANCED_MINECRAFT_MOD));
		}

		@Override
		public String getArmorTexture(ItemStack stack, Entity entity, EquipmentSlot slot, String type) {
			return "testmore:textures/models/armor/netheritearmor_layer_2.png";
		}
	}

	public static class Boots extends OnlyNAItem {
		public Boots() {
			super(EquipmentSlot.FEET, new Item.Properties().tab(TestmoreModTabs.TAB_ADVANCED_MINECRAFT_MOD));
		}

		@Override
		public String getArmorTexture(ItemStack stack, Entity entity, EquipmentSlot slot, String type) {
			return "testmore:textures/models/armor/netheritearmor_layer_1.png";
		}
	}
}
